%define debug_package %{nil}
%define oname	hybrid-v35
%define dwver	6_30_223_271
%define kname	wl

Summary:	Proprietary driver for Broadcom wireless adapters
Name:		broadcom-wl
Version:	6.30.223.271
Release:	%mkrel 66
Source0:	https://www.broadcom.com/docs/linux_sta/%{oname}-nodebug-pcoem-%{dwver}.tar.gz
Source1:	https://www.broadcom.com/docs/linux_sta/%{oname}_64-nodebug-pcoem-%{dwver}.tar.gz
Source2:	broadcom-wl-blacklist.conf
Source3:	broadcom-wl-alias.conf
# fix crash (ubuntu, mga#16390)
Patch6:		broadcom-wl-6.30.223.271-fix-null-pointer-crash.patch
# fix build with 4.3 (aur)
Patch7:		broadcom-wl-6.30.223.271-kernel-4.3-rdtscl-buildfix.patch
# (tmb) fix build with 4.7
Patch8:		broadcom-wl-6.30.223.271-kernel-4.7-buildfix.patch
# (tmb) fix build with 4.8 (aur)
Patch9:		broadcom-wl-6.30.223.271-kernel-4.8-buildfix.patch
# (tmb) fix build with 4.11 (debian)
Patch10:	broadcom-wl-6.30.223.271-kernel-4.11-buildfix.patch
# (tmb) fix build with 4.12 (aur)
Patch11:	broadcom-wl-6.30.223.271-kernel-4.12-buildfix.patch
# (tmb) fix build with 4.14 (debian)
Patch12:	broadcom-wl-6.30.223.271-kernel-4.14-buildfix.patch
# (tmb) fix build with 4.15 (debian)
Patch13:	broadcom-wl-6.30.223.271-kernel-4.15-buildfix.patch
# (tmb) fix build with 5.1
Patch14:	broadcom-wl-6.30.223.271-kernel-5.1-buildfix.patch
# fix kernel warnings (debian)
Patch15:	broadcom-wl-6.30.223.271-debian-fix-kernel-warnings.patch
# fix mac profile discrepancy (debian)
Patch16:	broadcom-wl-6.30.223.271-fix_mac_profile_discrepancy.patch
# Allow normal users to send ioctl requests (debian)
Patch17:	broadcom-wl-6.30.223.271-allow-user_ioctl.patch
# (tmb) default wifi interface name should be wlan, not eth
Patch18:	broadcom-wl-6.30.223.271-ifname-wlan.patch
# (tmb) fix build with 5.6
Patch19:	broadcom-wl-6.30.223.271-kernel-5.6-buildfix.patch
# (tmb) disable time-date warnign
Patch20:	broadcom-wl-6.30.223.271-no-date-time.patch
# fix build error "/bin/sh: 1: [: Illegal number:" (debian)
Patch21:	broadcom-wl-6.30.223.271-debian-fix-dkms-build-error.patch
# fix build with 5.9 (debian)
Patch22:	broadcom-wl-6.30.223.271-kernel-5.9-buildfix.patch
# fix build with 5.17
Patch23:	broadcom-wl-6.30.223.271-kernel-5.17.patch
# another fix for 5.17
# https://github.com/antoineco/broadcom-wl/commit/df12b9a8e87d9103a2a39c9353881cc9b4adfbba
Patch24:	broadcom-wl-6.30.223.271-kernel-5.17-fix2.patch
# fix build with 5.18
# https://github.com/antoineco/broadcom-wl/commit/b76c5dc970ddc8aa562393f580637e2c1b5b6ed7
Patch25:	broadcom-wl-6.30.223.271-kernel-5.18.patch
# fix build with 6.0.0
Patch26:	broadcom-wl-6.30.223.271-kernel-6.0.0.patch
# fix build with kernel 6.1
Patch27:	broadcom-wl-6.30.223.271-kernel-6.1.0.patch

# Blob is under a custom license (see LICENSE.txt), everything else
# is GPLv2 - AdamW 2008/12
License:	Freeware and GPLv2 with exception
Group:		System/Kernel and hardware
URL:		https://www.broadcom.com/support/802.11/linux_sta.php

%description
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%package -n dkms-%{name}
Summary:	Kernel module for Broadcom wireless adapters
Group:		System/Kernel and hardware
Provides:	kmod(%{kname}.ko) = %{version}
Requires:		dkms >= 2.0.19-37
Requires(post):		dkms >= 2.0.19-37
Requires(preun):	dkms >= 2.0.19-37
Requires:	%{name}-common
# (tmb) prebuilt kmods violates gpl
%ifarch %{ix86}
%rename		broadcom-wl-kernel-desktop586-latest
%endif
%rename		broadcom-wl-kernel-desktop-latest
%rename		broadcom-wl-kernel-server-latest

%description -n dkms-%{name}
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%package -n %{name}-common
Summary:	Common files for Broadcom-wl drivers
Group:		System/Kernel and hardware
Conflicts:	dkms-%{name} <= 5.100.82.112-7
Conflicts:	broadcom-bcma-config
Conflicts:	broadcom-ssb-config

%description -n %{name}-common
This package contains the blacklist and ldetect-lst files shared
between dkms-broadcom-wl and the prebuilt broadcom-wl-* drivers.

%prep
%ifarch x86_64
%setup -q -T -c -a1 %{oname}
%else
%setup -q -T -c -a0 %{oname}
%endif

%autopatch -p1

%build

%install
rm -rf %{buildroot}

# add blacklist for conflicting in-kernel modules
install -m755 -d %{buildroot}%{_sysconfdir}/modprobe.d/
install -m644 %{SOURCE2} %{buildroot}%{_sysconfdir}/modprobe.d
# add pciids for ldetect-lst and libkmod
install -m644 %{SOURCE3} %{buildroot}%{_sysconfdir}/modprobe.d

# install dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}
cp -R * %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/
cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
MAKE="'make' -j\${parallel_jobs} -C \$kernel_source_dir M=\\\$(pwd)"
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
DEST_MODULE_LOCATION=/kernel/3rdparty/%{name}
BUILT_MODULE_NAME=%{kname}
AUTOINSTALL=yes
EOF

%post -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release}
if [ -z "$DURING_INSTALL" ] ; then
    /usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release} &&
    /usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release}
fi

%preun -n dkms-%{name}
# rmmod can fail
/sbin/rmmod %{kname} >/dev/null 2>&1 ||:
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all || :

%posttrans -n %{name}-common
if [ -z "$DURING_INSTALL" ] ; then
    /sbin/rmmod b43 >/dev/null 2>&1 ||:
    /sbin/rmmod b43legacy >/dev/null 2>&1 ||:
    /sbin/rmmod brcmfmac >/dev/null 2>&1 ||:
    /sbin/rmmod brcmsmac >/dev/null 2>&1 ||:
    /sbin/rmmod bcma >/dev/null 2>&1 ||:
    /sbin/rmmod ssb >/dev/null 2>&1 ||:
    /sbin/modprobe wl >/dev/null 2>&1 ||:
fi

%clean
rm -rf %{buildroot}

%files -n dkms-%{name}
%doc lib/LICENSE.txt
%dir %{_usr}/src/%{name}-%{version}-%{release}
%{_usr}/src/%{name}-%{version}-%{release}/*

%files -n %{name}-common
%config %{_sysconfdir}/modprobe.d/%{name}-alias.conf
%config %{_sysconfdir}/modprobe.d/%{name}-blacklist.conf


%changelog
* Sun Jan 01 2023 tmb <tmb> 6.30.223.271-66.mga8
+ Revision: 1928607
- fix build with kernel 6.1 series
- update kernel module blacklist
- fix build with kernel 6.0 series
- add support for 5.17 and 5.18 series kernels

* Wed Oct 14 2020 luigiwalser <luigiwalser> 6.30.223.271-61.mga8.nonfree
+ Revision: 1636134
- fix dkms build error (debian)
- fix build with kernel 5.9 (debian)

* Fri May 15 2020 tmb <tmb> 6.30.223.271-60.mga8.nonfree
+ Revision: 1583966
- fix build with gcc-10 (mga#26620)

* Fri May 08 2020 tmb <tmb> 6.30.223.271-59.mga8.nonfree
+ Revision: 1581651
- rebuild with gcc 10.1

* Sat Apr 11 2020 tmb <tmb> 6.30.223.271-58.mga8.nonfree
+ Revision: 1566327
- fix build with kernel 5.6

* Fri Feb 21 2020 umeabot <umeabot> 6.30.223.271-56.mga8.nonfree
+ Revision: 1548602
- Mageia 8 Mass Rebuild

* Sat Jan 11 2020 tmb <tmb> 6.30.223.271-55.mga8
+ Revision: 1477550
- rebase patches, sync P11 with debian
- fix kernel warnings (debian)
- fix mac profile discrepancy (debian)
- allow normal users to send ioctl requests (debian)
- default wifi interface name should be wlan, not eth

* Tue Aug 13 2019 tmb <tmb> 6.30.223.271-54.mga8.nonfree
+ Revision: 1429250
- rebuild with gcc 9.2

* Mon Apr 22 2019 tmb <tmb> 6.30.223.271-53.mga7.nonfree
+ Revision: 1394665
- fix build with 5.1 series kernels

* Wed Mar 06 2019 tmb <tmb> 6.30.223.271-52.mga7.nonfree
+ Revision: 1372024
- rebuild with gcc 8.3 final

* Thu Sep 20 2018 umeabot <umeabot> 6.30.223.271-50.mga7.nonfree
+ Revision: 1277781
- Mageia 7 Mass Rebuild

* Thu Apr 12 2018 tmb <tmb> 6.30.223.271-49.mga7.nonfree
+ Revision: 1217987
- fix build with 4.14 and 4.15+ series kernels (debian)

* Sat Sep 02 2017 tmb <tmb> 6.30.223.271-48.mga7.nonfree
+ Revision: 1150685
- rebuild with new gcc/binutils

* Sat Aug 05 2017 tmb <tmb> 6.30.223.271-47.mga7.nonfree
+ Revision: 1135159
- add support for kernel 4.12 (from arch)

* Wed Apr 26 2017 tmb <tmb> 6.30.223.271-46.mga6.nonfree
+ Revision: 1097661
- dont trigger dkms build during classical install (mga#20155)

* Sat Dec 10 2016 tmb <tmb> 6.30.223.271-45.mga6.nonfree
+ Revision: 1073931
- support kernel 4.8 series (mga#19866, aur)

* Mon Jul 04 2016 tmb <tmb> 6.30.223.271-44.mga6.nonfree
+ Revision: 1038669
- fix build with kernel 4.7 series

* Wed Jun 15 2016 tmb <tmb> 6.30.223.271-43.mga6.nonfree
+ Revision: 1021613
- hook into dkms parallel build support

* Mon May 30 2016 tmb <tmb> 6.30.223.271-42.mga6.nonfree
+ Revision: 1019491
- fix duplicated/broken provides on dkms package
- rebuild with gcc 5.4
- obsolete prebuilt kmods as they violate GPL

* Sat Dec 05 2015 tmb <tmb> 6.30.223.271-4.mga6.nonfree
+ Revision: 908284
- rebuild with gcc 5.3 final

* Sun Nov 22 2015 tmb <tmb> 6.30.223.271-3.mga6.nonfree
+ Revision: 904846
- fix 32bit build with 4.3 series kernels

* Sun Nov 22 2015 tmb <tmb> 6.30.223.271-2.mga6.nonfree
+ Revision: 904838
- rebuild for missing package

* Mon Oct 05 2015 tmb <tmb> 6.30.223.271-1.mga6.nonfree
+ Revision: 886447
- update to 6.30.223.271 (mga#16908)
  * drop patches P1-P5, P7

* Wed Sep 30 2015 tmb <tmb> 6.30.223.248-8.mga6.nonfree
+ Revision: 885376
- fix build with kernel 4.2

* Wed Sep 09 2015 neoclust <neoclust> 6.30.223.248-7.mga6.nonfree
+ Revision: 874957
- Fix build with new rpm ( empty debuginfo)

* Fri Aug 21 2015 tmb <tmb> 6.30.223.248-6.mga6.nonfree
+ Revision: 867071
- rebuild for new gcc

* Thu Aug 20 2015 tmb <tmb> 6.30.223.248-5.mga6
+ Revision: 866759
- rebuild with gcc 5.2.1

* Tue Jul 21 2015 tmb <tmb> 6.30.223.248-4.mga6.nonfree
+ Revision: 856015
- fix null pointer crash (mga#16390)

* Tue Jul 07 2015 tmb <tmb> 6.30.223.248-3.mga6.nonfree
+ Revision: 852312
- fix build with 4.0+ series kernels

* Mon Dec 08 2014 tmb <tmb> 6.30.223.248-2.mga5.nonfree
+ Revision: 802163
- fix up P4

* Sat Dec 06 2014 doktor5000 <doktor5000> 6.30.223.248-1.mga5.nonfree
+ Revision: 801751
- new version 6.30.223.248
- dropped broadcom-wl-6.30.223.141-kernel-3.10.patch
- rediffed broadcom-wl-gcc-4.9.patch
- rediffed broadcom-wl-6.30.223.141-kernel-3.18.patch to broadcom-wl-6.30.223.248-kernel-3.18.patch

* Sat Nov 29 2014 tmb <tmb> 6.30.223.141-11.mga5.nonfree
+ Revision: 799913
- fix build with 3.18 series kernels

* Wed Oct 15 2014 umeabot <umeabot> 6.30.223.141-10.mga5.nonfree
+ Revision: 739991
- Second Mageia 5 Mass Rebuild

* Wed Sep 24 2014 tmb <tmb> 6.30.223.141-9.mga5.nonfree
+ Revision: 723708
- fix typo in kmod provides

* Wed Sep 24 2014 tmb <tmb> 6.30.223.141-8.mga5.nonfree
+ Revision: 723644
- adapt to new kmod provides

* Tue Sep 16 2014 umeabot <umeabot> 6.30.223.141-7.mga5.nonfree
+ Revision: 678228
- Mageia 5 Mass Rebuild

* Wed Sep 03 2014 tmb <tmb> 6.30.223.141-6.mga5.nonfree
+ Revision: 671155
- fix build with 3.17 series kernels

* Mon Jun 09 2014 tmb <tmb> 6.30.223.141-5.mga5.nonfree
+ Revision: 634874
- fix build with kernel-3.15

* Wed May 14 2014 tmb <tmb> 6.30.223.141-4.mga5.nonfree
+ Revision: 622723
- fix kmod build with gcc 4.9

* Tue May 13 2014 tmb <tmb> 6.30.223.141-3.mga5.nonfree
+ Revision: 622567
- rebuild with gcc 4.9

* Thu Oct 31 2013 tmb <tmb> 6.30.223.141-2.mga4.nonfree
+ Revision: 548329
- Mageia 4 rebuild

* Sat Oct 05 2013 tmb <tmb> 6.30.223.141-1.mga4.nonfree
+ Revision: 492028
- update and sort aliases list
- fix build with kernel-3.10+ (openmamba)
- drop obsolete patches
- update to 6.30.223.141

* Sun Aug 11 2013 tmb <tmb> 5.100.82.112-14.mga4.nonfree
+ Revision: 465469
- rebuild with new gcc

* Mon Jul 15 2013 tmb <tmb> 5.100.82.112-13.mga4.nonfree
+ Revision: 454864
- fix build with kernel 3.10 (P2, aur)

* Sat May 04 2013 tmb <tmb> 5.100.82.112-12.mga3.nonfree
+ Revision: 412316
- silence rmmod warnings when modules are not loaded

* Sat May 04 2013 tmb <tmb> 5.100.82.112-11.mga3.nonfree
+ Revision: 412262
- conflict broadcom-bcma-config and broadcom-ssb-config
- remove reference to nonexisting brcm80211
- unload conflicting drivers and load wl driver when installed

* Fri Feb 08 2013 tmb <tmb> 5.100.82.112-10.mga3.nonfree
+ Revision: 396959
- blacklist b43legacy, brcmsmac and brcmfmac too

* Wed Jan 23 2013 tmb <tmb> 5.100.82.112-9.mga3.nonfree
+ Revision: 391728
- fix alias list so it is actually used when installed

* Wed Jan 23 2013 tmb <tmb> 5.100.82.112-8.mga3.nonfree
+ Revision: 391697
- add pciids for ldetect-lst to detect wl drivers when installed
- split out module blacklist to a separate -common package

* Fri Jan 11 2013 umeabot <umeabot> 5.100.82.112-7.mga3.nonfree
+ Revision: 347202
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Jan 10 2013 tmb <tmb> 5.100.82.112-6.mga3.nonfree
+ Revision: 344817
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon May 28 2012 tmb <tmb> 5.100.82.112-5.mga3.nonfree
+ Revision: 247960
- fix build with 3.4 series kernels (P1)

* Mon Dec 26 2011 tmb <tmb> 5.100.82.112-4.mga2.nonfree
+ Revision: 187931
- fix build with 3.2 series kernels
- drop unused .conf file
- drop buildroot and defattr

* Mon Dec 05 2011 zezinho <zezinho> 5.100.82.112-3.mga2.nonfree
+ Revision: 177045
- blacklist more modules to fix #3618

* Tue Nov 08 2011 zezinho <zezinho> 5.100.82.112-2.mga2.nonfree
+ Revision: 165305
- bump release because it is also in 1/updates

* Tue Nov 08 2011 zezinho <zezinho> 5.100.82.112-1.mga2.nonfree
+ Revision: 165290
- new version

* Sun Apr 10 2011 tmb <tmb> 5.100.82.38-3.mga1
+ Revision: 83052
- blacklist brcm80211 if wl module is installed (#327)

* Sun Mar 20 2011 tmb <tmb> 5.100.82.38-2.mga1
+ Revision: 75009
- fix build with 2.6.37+ series kernels (#438)

* Thu Mar 17 2011 tmb <tmb> 5.100.82.38-1.mga1
+ Revision: 73292
- imported package broadcom-wl

